public class Pile<E> {

private E[] tab;
private int etage;

@SuppressWarnings("unchecked")
public Pile(){


tab = (E[]) new Object[50];
etage=0;



}


public void push(E element){
if(etage == tab.length){


System.out.println("Erreur la pile est pleine !");
return;


}

tab[etage]=element;
etage++;




}


public E pop(){
if(empty()){

System.out.println("Erreur : la pile est vide !");
return null;

}

etage--;
E valeur = tab[etage];
tab[etage]=null;
return valeur;

}

public boolean empty(){



    return etage==0;


}









}